## ros-rolling-rplidar-ros 2.1.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.9.5)
project(rplidar_ros)

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 17)
endif()
if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -pedantic)
endif()

set(RPLIDAR_SDK_PATH "./sdk/")

if(APPLE)
add_compile_definitions(_MACOS)
FILE(GLOB RPLIDAR_SDK_SRC
  "${RPLIDAR_SDK_PATH}/src/arch/macOS/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/hal/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/*.cpp"
)
else()
FILE(GLOB RPLIDAR_SDK_SRC
  "${RPLIDAR_SDK_PATH}/src/arch/linux/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/hal/*.cpp"
  "${RPLIDAR_SDK_PATH}/src/*.cpp"
)
endif()

set(req_deps
  "rclcpp"
  "sensor_msgs"
  "std_srvs"
  "rclcpp_components"
)

find_package(ament_cmake_auto REQUIRED)
find_package(ament_cmake_ros REQUIRED)

ament_auto_find_build_dependencies(REQUIRED ${req_deps})

include_directories(
  ${RPLIDAR_SDK_PATH}/include
  ${RPLIDAR_SDK_PATH}/src
  include
)

# build composition node
add_library(rplidar_composition_node SHARED
  src/rplidar_node.cpp
  ${RPLIDAR_SDK_SRC}
)
ament_target_dependencies(rplidar_composition_node ${req_deps})
rclcpp_components_register_nodes(rplidar_composition_node "rplidar_ros::rplidar_node")

# build composition node
ament_auto_add_executable(rplidar_composition src/standalone_rplidar.cpp)
target_link_libraries(rplidar_composition rplidar_composition_node)
ament_target_dependencies(rplidar_composition ${req_deps})

install(
  TARGETS rplidar_composition
  DESTINATION lib/${PROJECT_NAME}
)

install(
  DIRECTORY launch rviz
  DESTINATION share/${PROJECT_NAME}
)

# Install the shared library composition node
install(
  TARGETS rplidar_composition_node
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# TODO(hallen): port this
# install(DIRECTORY sdk
#   USE_SOURCE_PERMISSIONS
# )

ament_auto_package()

## ros-rolling-rplidar-ros 2.0.2

=== debian/changelog ===
ros-rolling-rplidar-ros (2.0.2-1focal) focal; urgency=high

  * Remove test_rplidar.launch.py, since relevant executables no longer exist (#24 <https://github.com/allenh1/rplidar_ros/issues/24>)
  * Contributors: Hunter L. Allen

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 27 May 2021 04:00:00 -0000

ros-rolling-rplidar-ros (2.0.1-1focal) focal; urgency=high

  * Remove old driver (#21 <https://github.com/allenh1/rplidar_ros/issues/21>)
    * Remove old rplidar driver in favor of the component version
    * Lint the source
  * Fix incompatibilities with slam_toolbox (#20 <https://github.com/allenh1/rplidar_ros/issues/20>)
    * Fix incompatibilities with slam_toolbox:
    - Fix angle compensate mode to publish angle compensated values
    - Fix angle_increment calculation
    - Add optional flip_x_axis option to deal with issue discussed here: https://github.com/SteveMacenski/slam_toolbox/issues/198.  Flip x-axis can be used when laser is mounted with motor behind it as rotated TF laser frame doesn't seem to work with slam_toolbox.
    * Fix whitespace
  * Fix node count for component implementation (#19 <https://github.com/allenh1/rplidar_ros/issues/19>)
  * Slam Toolbox compatibility (#18 <https://github.com/allenh1/rplidar_ros/issues/18>)
    (cherry picked from commit f21079fea8eca8946b5b4ae72f50b8d9f1ac46a2)
  * Fix building with GCC 10 (#17 <https://github.com/allenh1/rplidar_ros/issues/17>)
  * Contributors: Christen Lofland, Hunter L. Allen, justinIRBT

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Sun, 13 Sep 2020 04:00:00 -0000

ros-rolling-rplidar-ros (2.0.0-1focal) focal; urgency=high

  * Update SDK to Version 0.12.0 (#14 <https://github.com/allenh1/rplidar_ros/issues/14>)
    * Register the rclcpp component
    * Update RPLIDAR SDK to version 1.12.0
  * Update ROS 2 parameters and use node's clock instance (#9 <https://github.com/allenh1/rplidar_ros/issues/9>)
    * Update ROS 2 parameters and use node's clock instance
    * Fix scan_mode listing output
    * Stop motors and exit when set_scan_mode() call fails
  * Fix compilation with eloquent (#6 <https://github.com/allenh1/rplidar_ros/issues/6>)
  * Use Composition node with launch files (#4 <https://github.com/allenh1/rplidar_ros/issues/4>)
  * Composable nodes (#3 <https://github.com/allenh1/rplidar_ros/issues/3>)
    * Begin implementation of composable rplidar_ros::rplidar_node
    * Declare composition node library in CMake, as well as continue the port
    * Get to a compiling state
    * Add start/stop motor callbacks + more driver setup
    * Add publish loop for scans
    * Add composition node
    * Lint
  * Port rviz and launch files to ROS2 (#2 <https://github.com/allenh1/rplidar_ros/issues/2>)
    * Port non-rviz launch files to ROS2
    * Compatibility with rviz2
    * revert whitespace changes
    * Port the remaining launch files to ROS2
    * Revert more whitespace changes
    * Fix luanch and rviz install path indent level
  * Ros2 port (#1 <https://github.com/allenh1/rplidar_ros/issues/1>)
    ROS 2 port
    * Port CMakeLists.txt
    * Port package.xml
    * Port client.cpp
    * Port node.cpp
    Fix compilation
  * Support TCP
  * upgrade sdk 1.10.0
  * upgrade sdk 1.9.0
    [new feature] support baudrate 57600 and 1382400, support HQ scan response
    [bugfix] TCP channel doesn't work
    [improvement] Print warning messages when deprecated APIs are called; imporve angular accuracy for ultra capsuled scan points
  * [bugfix]modify scan_mode at test_rplidar.launch and test_rplidar_a3.launch
  * Contributors: Dan Rose, Hunter L. Allen, WubinXia, kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Wed, 15 Jul 2020 04:00:00 -0000

ros-rolling-rplidar-ros (1.10.0-1focal) focal; urgency=high

  * Update RPLIDAR SDK to 1.10.0
  * [new feature] support Rplidar S1
  * Contributors: tony,WubinXia

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Fri, 22 Feb 2019 05:00:00 -0000

ros-rolling-rplidar-ros (1.9.0-1focal) focal; urgency=high

  * Update RPLIDAR SDK to 1.9.0
  * [new feature] support baudrate 57600 and 1382400, support HQ scan response
  * [bugfix] TCP channel doesn't work
  * [improvement] Print warning messages when deprecated APIs are called; imporve angular accuracy for ultra capsuled scan points
  * Contributors: tony,kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Fri, 24 Aug 2018 04:00:00 -0000

ros-rolling-rplidar-ros (1.7.0-1focal) focal; urgency=high

  * Update RPLIDAR SDK to 1.7.0
  * support scan points farther than 16.38m
  * upport display and set scan mode
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 19 Jul 2018 04:00:00 -0000

ros-rolling-rplidar-ros (1.6.0-1focal) focal; urgency=high

  * Release 1.6.0.
  * Update RPLIDAR SDK to 1.6.0
  * Support new product RPLIDAR A3(default 16K model and max_distance 25m)
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Mon, 21 May 2018 04:00:00 -0000

ros-rolling-rplidar-ros (1.5.7-1focal) focal; urgency=high

  * Release 1.5.7.
  * Update RPLIDAR SDK to 1.5.7
  * Fixed the motor default speed at 10 HZ. Extend the measurement of max_distance from 6m to 8m.
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 15 Dec 2016 05:00:00 -0000

ros-rolling-rplidar-ros (1.5.5-1focal) focal; urgency=high

  * Release 1.5.5.
  * Update RPLIDAR SDK to 1.5.5
  * Add RPLIDAR information print, and fix the standard motor speed of RPLIDAR A2.
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Tue, 23 Aug 2016 04:00:00 -0000

ros-rolling-rplidar-ros (1.5.4-1focal) focal; urgency=high

  * Release 1.5.4.
  * Update RPLIDAR SDK to 1.5.4
  * Support RPLIDAR A2
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 02 Jun 2016 04:00:00 -0000

ros-rolling-rplidar-ros (1.5.2-1focal) focal; urgency=high

  * Release 1.5.2.
  * Update RPLIDAR SDK to 1.5.2
  * Support RPLIDAR A2
  * Contributors: kint



=== debian/control ===
Source: ros-rolling-rplidar-ros
Section: misc
Priority: optional
Maintainer: Hunter L. Allen <hunterlallen@protonmail.com>
Build-Depends: debhelper (>= 9.0.0), ros-rolling-ament-cmake-auto, ros-rolling-ament-cmake-ros, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-std-srvs, ros-rolling-ros-workspace
Homepage: 
Standards-Version: 3.9.2

Package: ros-rolling-rplidar-ros
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-rolling-rclcpp, ros-rolling-rclcpp-components, ros-rolling-sensor-msgs, ros-rolling-std-srvs, ros-rolling-ros-workspace
Description: The rplidar ros package, support rplidar A2/A1 and A3/S1

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/rolling/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-rolling-rplidar-ros//opt/ros/rolling/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/rolling/setup.sh" ]; then . "/opt/ros/rolling/setup.sh"; fi && \
	dh_auto_install

## ros-rolling-rplidar-ros 2.1.0

=== debian/changelog ===
ros-rolling-rplidar-ros (2.1.0-2jammy) jammy; urgency=high

  * Add auto standby mode (#29 <https://github.com/allenh1/rplidar_ros/issues/29>)
    * Add auto standby mode
    Turn on/off motor based on topic subsribers
    * Set auto_standby off by default
  * Fix building on Apple machines (#30 <https://github.com/allenh1/rplidar_ros/issues/30>)
  * Update README & fix launch files for Foxy and up (#26 <https://github.com/allenh1/rplidar_ros/issues/26>)
    * Update README.md
    based on modifications from youngday
    * Update launch files for Foxy or later
  * Contributors: Jesse Zhang, Vasily Kiniv

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Tue, 06 Sep 2022 07:00:00 -0000

ros-rolling-rplidar-ros (2.0.3-2jammy) jammy; urgency=high

  * Fix build with later versions of GCC
  * Contributors: Hunter L. Allen

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 01 Sep 2022 07:00:00 -0000

ros-rolling-rplidar-ros (2.0.2-2jammy) jammy; urgency=high

  * Remove test_rplidar.launch.py, since relevant executables no longer exist (#24 <https://github.com/allenh1/rplidar_ros/issues/24>)
  * Contributors: Hunter L. Allen

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 27 May 2021 07:00:00 -0000

ros-rolling-rplidar-ros (2.0.1-2jammy) jammy; urgency=high

  * Remove old driver (#21 <https://github.com/allenh1/rplidar_ros/issues/21>)
    * Remove old rplidar driver in favor of the component version
    * Lint the source
  * Fix incompatibilities with slam_toolbox (#20 <https://github.com/allenh1/rplidar_ros/issues/20>)
    * Fix incompatibilities with slam_toolbox:
    - Fix angle compensate mode to publish angle compensated values
    - Fix angle_increment calculation
    - Add optional flip_x_axis option to deal with issue discussed here: https://github.com/SteveMacenski/slam_toolbox/issues/198.  Flip x-axis can be used when laser is mounted with motor behind it as rotated TF laser frame doesn't seem to work with slam_toolbox.
    * Fix whitespace
  * Fix node count for component implementation (#19 <https://github.com/allenh1/rplidar_ros/issues/19>)
  * Slam Toolbox compatibility (#18 <https://github.com/allenh1/rplidar_ros/issues/18>)
    (cherry picked from commit f21079fea8eca8946b5b4ae72f50b8d9f1ac46a2)
  * Fix building with GCC 10 (#17 <https://github.com/allenh1/rplidar_ros/issues/17>)
  * Contributors: Christen Lofland, Hunter L. Allen, justinIRBT

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Sun, 13 Sep 2020 07:00:00 -0000

ros-rolling-rplidar-ros (2.0.0-2jammy) jammy; urgency=high

  * Update SDK to Version 0.12.0 (#14 <https://github.com/allenh1/rplidar_ros/issues/14>)
    * Register the rclcpp component
    * Update RPLIDAR SDK to version 1.12.0
  * Update ROS 2 parameters and use node's clock instance (#9 <https://github.com/allenh1/rplidar_ros/issues/9>)
    * Update ROS 2 parameters and use node's clock instance
    * Fix scan_mode listing output
    * Stop motors and exit when set_scan_mode() call fails
  * Fix compilation with eloquent (#6 <https://github.com/allenh1/rplidar_ros/issues/6>)
  * Use Composition node with launch files (#4 <https://github.com/allenh1/rplidar_ros/issues/4>)
  * Composable nodes (#3 <https://github.com/allenh1/rplidar_ros/issues/3>)
    * Begin implementation of composable rplidar_ros::rplidar_node
    * Declare composition node library in CMake, as well as continue the port
    * Get to a compiling state
    * Add start/stop motor callbacks + more driver setup
    * Add publish loop for scans
    * Add composition node
    * Lint
  * Port rviz and launch files to ROS2 (#2 <https://github.com/allenh1/rplidar_ros/issues/2>)
    * Port non-rviz launch files to ROS2
    * Compatibility with rviz2
    * revert whitespace changes
    * Port the remaining launch files to ROS2
    * Revert more whitespace changes
    * Fix luanch and rviz install path indent level
  * Ros2 port (#1 <https://github.com/allenh1/rplidar_ros/issues/1>)
    ROS 2 port
    * Port CMakeLists.txt
    * Port package.xml
    * Port client.cpp
    * Port node.cpp
    Fix compilation
  * Support TCP
  * upgrade sdk 1.10.0
  * upgrade sdk 1.9.0
    [new feature] support baudrate 57600 and 1382400, support HQ scan response
    [bugfix] TCP channel doesn't work
    [improvement] Print warning messages when deprecated APIs are called; imporve angular accuracy for ultra capsuled scan points
  * [bugfix]modify scan_mode at test_rplidar.launch and test_rplidar_a3.launch
  * Contributors: Dan Rose, Hunter L. Allen, WubinXia, kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Wed, 15 Jul 2020 07:00:00 -0000

ros-rolling-rplidar-ros (1.10.0-2jammy) jammy; urgency=high

  * Update RPLIDAR SDK to 1.10.0
  * [new feature] support Rplidar S1
  * Contributors: tony,WubinXia

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Fri, 22 Feb 2019 08:00:00 -0000

ros-rolling-rplidar-ros (1.9.0-2jammy) jammy; urgency=high

  * Update RPLIDAR SDK to 1.9.0
  * [new feature] support baudrate 57600 and 1382400, support HQ scan response
  * [bugfix] TCP channel doesn't work
  * [improvement] Print warning messages when deprecated APIs are called; imporve angular accuracy for ultra capsuled scan points
  * Contributors: tony,kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Fri, 24 Aug 2018 07:00:00 -0000

ros-rolling-rplidar-ros (1.7.0-2jammy) jammy; urgency=high

  * Update RPLIDAR SDK to 1.7.0
  * support scan points farther than 16.38m
  * upport display and set scan mode
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Thu, 19 Jul 2018 07:00:00 -0000

ros-rolling-rplidar-ros (1.6.0-2jammy) jammy; urgency=high

  * Release 1.6.0.
  * Update RPLIDAR SDK to 1.6.0
  * Support new product RPLIDAR A3(default 16K model and max_distance 25m)
  * Contributors: kint

 -- Hunter L. Allen <hunterlallen@protonmail.com>  Mon, 21 May 2018 07:00:00 -0000

ros-rolling-rplidar-ros (1.5.7-2jammy) jammy; urgency=high

  * Release 1.5.7.


=== debian/rules ===
--- 
+++ 
@@ -17,9 +17,14 @@
 # Explicitly enable -DNDEBUG, see:
 # 	https://github.com/ros-infrastructure/bloom/issues/327
 export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
+ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
+	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
+endif
+
+DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
 
 %:
-	dh $@ -v --buildsystem=cmake
+	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)
 
 override_dh_auto_configure:
 	# In case we're installing to a non-standard location, look for a setup.sh
@@ -29,7 +34,8 @@
 	dh_auto_configure -- \
 		-DCMAKE_INSTALL_PREFIX="/opt/ros/rolling" \
 		-DAMENT_PREFIX_PATH="/opt/ros/rolling" \
-		-DCMAKE_PREFIX_PATH="/opt/ros/rolling"
+		-DCMAKE_PREFIX_PATH="/opt/ros/rolling" \
+		$(BUILD_TESTING_ARG)
 
 override_dh_auto_build:
 	# In case we're installing to a non-standard location, look for a setup.sh
